SystemOrganization addCategory: #'Rizel-Tools'!

Object subclass: #RizelAbstractConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:56'!
buildBenchmarks
	^ self class allSelectors
		select: [:selector | selector beginsWith: 'bench']! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:08'!
executeBenchmark: aBlock 
	^ (self factor) timesRepeat: aBlock.! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:08'!
factor
	^ 1! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:53'!
loadVersion: version
	^ self subclassResponsability.! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:54'!
open
	| browser |
	browser := Rizel new.
	browser model: self.
	browser benchmarks: self buildBenchmarks.
	browser openWithSpec.
	^ browser! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 00:02'!
packageRegex
	^ self subclassResponsability.! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 23:59'!
profile: benchmark in: version 
	self loadVersion: version.
	"cleaning memory"
	10 timesRepeat: [Smalltalk garbageCollect.].
	Object new. Object new.
	10 timesRepeat: [Smalltalk garbageCollect.].
	"cleaning memory"
	^ self profilerClass
		profile: [self executeBenchmark: [self perform:benchmark]]
		inPackagesMatching: (self packageRegex).! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:52'!
profilerClass
	^ RzProfilerSpy! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:56'!
versionLabel
	^ self subclassResponsability.! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:57'!
versions
	^ self subclassResponsability.! !

RizelAbstractConfig subclass: #RizelPackageConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelPackageConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 01:27'!
loadVersion: versionName

	Gofer new url: (self url);
		 version: versionName;
		 load.! !

!RizelPackageConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 01:15'!
parseName: aString
	| basicName package branch author versionNumber|
	basicName := aString last isDigit
		ifTrue: [ aString ]
		ifFalse: [ (aString copyUpToLast: $.) copyUpTo: $( ].
	package := basicName copyUpToLast: $-.
	(package includes: $.)
		ifFalse: [ branch := '' ]
		ifTrue: [
			branch := package copyAfter: $..
			package := package copyUpTo: $. ].
	author := (basicName copyAfterLast: $-) copyUpToLast: $..
	versionNumber := (basicName copyAfterLast: $-) copyAfterLast: $..
	(versionNumber notEmpty and: [ versionNumber allSatisfy: [ :each | each isDigit ] ])
		ifTrue: [ versionNumber := versionNumber asInteger ]
		ifFalse: [ versionNumber := 0 ].
	^ versionNumber asString.! !

!RizelPackageConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 00:00'!
url
	^ self subclassResponsability.! !

!RizelPackageConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 01:14'!
versionLabel
	^ [ :v| self parseName: v].! !

RizelAbstractConfig subclass: #RizelProjectConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelProjectConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:53'!
configurationClass
	^ self subclassResponsability! !

!RizelProjectConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:58'!
loadVersion: version
	version load.! !

!RizelProjectConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:30'!
versionLabel
	^ [ :v| v versionNumber asString].! !

!RizelProjectConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:29'!
versions
	^ (((self configurationClass project 
						versions select:[ :v|  v importedVersions size >0]) reversed) asOrderedCollection).! !

ComposableModel subclass: #Rizel
	instanceVariableNames: 'versions benchmarks model options roassal benchs morphView profilePicker builder result versionLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!Rizel class methodsFor: 'spec' stamp: 'JuanPabloSandovalA 8/29/2012 04:40'!
defaultSpec
	
	^ SpecLayout composed
		newRow: [:r |
			r 
				newColumn: [:c | 
					c 
						add: #options height: 25;
						add: #benchmarks;
						add: #versions ] width: 150;
				newColumn: [:c | 
					c
						add: #roassal ]]! !

!Rizel class methodsFor: 'spec' stamp: 'JuanPabloSandovalA 8/20/2012 01:30'!
openWith: conf
	| builder |
	builder := Rizel new.
	builder configurationModel: conf.
	builder openWithSpec.
	^ builder! !

!Rizel class methodsFor: 'spec' stamp: ''!
title
	^ 'Rizel'! !

!Rizel methodsFor: 'accessing' stamp: ''!
addBench: t1 
	benchs add: t1.
	self benchmarks: benchs! !

!Rizel methodsFor: 'action' stamp: ''!
addBenchmark
	BenchmarkBrowser openOn: self! !

!Rizel methodsFor: 'accessing' stamp: ''!
benchmarks
	^ benchmarks! !

!Rizel methodsFor: 'accessing' stamp: ''!
benchmarks: t1 
	self benchmarks items: t1! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalA 8/20/2012 01:17'!
compare
	| A B merge |
	(self validateBeforeCompare) ifFalse:[^ self].
	A := model profile: profilePicker A second in: profilePicker A first.
	B := model profile: profilePicker B second in: profilePicker B first.
	merge := profilePicker A first > profilePicker B first
				ifTrue: [RzProfile merge: B with: A]
				ifFalse: [RzProfile merge: A with: B].
	(RzVisualizerMerge on: merge) visualize! !

!Rizel methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	benchs := OrderedCollection new! !

!Rizel methodsFor: 'initialization' stamp: ''!
initializeWidgets
	versions := self instantiate: ListComposableModel.
	versions beMultipleSelection.
	benchmarks := self instantiate: ListComposableModel.
	benchmarks
		displayBlock: [:t1 | t1 asString].
	benchmarks beMultipleSelection.
	options := self instantiate: RizelOptions.
	options browser: self.
	roassal := self instantiate: RoassalModel! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/20/2012 01:34'!
model: anObject
	model := anObject.
	self versions: model versions.
	versions displayBlock: model versionLabel! !

!Rizel methodsFor: 'accessing' stamp: ''!
options
	^ options! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalA 9/7/2012 10:30'!
profile
	(self validateBeforeProfile) ifFalse:[^ self].
	builder := RzBuilder new.
	builder
		define: #input
		named: #version
		with: self selectedVersions asSortedCollection.
	builder
		define: #input
		named: #benchmark
		with: self selectedBenchmarks.
	result := builder
				execute: [:version :bench | 
					model loadVersion: version.
					[model executeBenchmark: [model perform: bench]] timeToRun].
	profilePicker := RzVisualizer2D new.
	profilePicker xValues: self selectedVersions;
		 yValues: self selectedBenchmarks;
		 xLabel: model versionLabel;
		yLabel: [:t1 | t1 asString];
		value: [:t1 :t2 | result at: RzVector <== t1 + t2];
		 padding: 80;
		 visualizeOn: self view.
	self view applyLayout.
	roassal update.! !

!Rizel methodsFor: 'accessing' stamp: ''!
roassal
	^ roassal! !

!Rizel methodsFor: 'accessing' stamp: ''!
selectedBenchmarks
	^ self benchmarks selectedItems asSortedCollection! !

!Rizel methodsFor: 'accessing' stamp: ''!
selectedVersions
	^ self versions selectedItems asSortedCollection! !

!Rizel methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 01:19'!
validateBeforeCompare
	((profilePicker A isNil) or:[ profilePicker B isNil]) ifTrue:[
		UIManager default alert: 'you need to choose two boxes' title:'Rizel'.
		^ false].
	(profilePicker A first = profilePicker B first) ifTrue:[
		UIManager default alert: 'you need to select choose two boxes of different version' title:'Rizel'.
		^ false].
	(profilePicker A second = profilePicker B second) ifFalse:[
		UIManager default alert: 'you need to select choose two boxes of the same benchmark' title:'Rizel'.
		^ false].
	^ true.! !

!Rizel methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 01:18'!
validateBeforeProfile
	(self selectedBenchmarks size > 0) ifFalse:[
		UIManager default alert: 'you need to select benchmarks' title:'Rizel'.
		^ false.].
	(self selectedVersions size > 0) ifFalse:[
		UIManager default alert: 'you need to select versions' title:'Rizel'.
		^ false.].
	^ true.! !

!Rizel methodsFor: 'rizel' stamp: ''!
versionLabel: t1 
	versionLabel := t1! !

!Rizel methodsFor: 'accessing' stamp: ''!
versions
	^ versions! !

!Rizel methodsFor: 'accessing' stamp: ''!
versions: t1 
	self versions items: t1! !

!Rizel methodsFor: 'accessing' stamp: ''!
view
	^ roassal view! !

ComposableModel subclass: #RizelMergeBrowser
	instanceVariableNames: 'merge metrics visualization sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelMergeBrowser class methodsFor: 'spec' stamp: 'JuanPabloSandovalAlcocer 1/19/2013 20:57'!
defaultSpec
	^ SpecLayout composed
		newRow: [ :row |
			row newColumn: [ :col | 
					col add: #metrics] width: 200;
				newColumn: [ :col | 
					col add: #visualization ]] origin: (0@0) corner:(1@0.5);
		newRow: [ :row |
			row add:#sourceCode. ] origin: (0@0.5) corner: (1@1).! !

!RizelMergeBrowser class methodsFor: 'class initialization' stamp: 'JuanPabloSandovalAlcocer 12/13/2012 17:45'!
openWith: rzProfile
	| builder |
	builder := RizelMergeBrowser new.
	builder merge: rzProfile.
	builder openWithSpec.
	builder render.
	^ builder! !

!RizelMergeBrowser class methodsFor: 'class initialization' stamp: 'JuanPabloSandovalAlcocer 12/13/2012 17:41'!
title
	^ 'Rizel'! !

!RizelMergeBrowser methodsFor: 'initialization' stamp: 'JuanPabloSandovalAlcocer 12/14/2012 16:18'!
initializeWidgets
	metrics := self instantiate: ListComposableModel.
	visualization := self instantiate: RoassalModel.
	sourceCode := (DiffMorph from: '' to: '')
						vResizing: #spaceFill;
						hResizing: #spaceFill;
						yourself.! !

!RizelMergeBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/13/2012 17:42'!
merge: rzProfile
	merge := rzProfile.! !

!RizelMergeBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/13/2012 17:32'!
metrics
	^ metrics.! !

!RizelMergeBrowser methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 12/14/2012 16:39'!
onClick: Event
	|model from to|
	model := Event element model.
	from := model property:#copySourceCode from:#old ifAbsent: [''].
	to := model property:#copySourceCode from:#new ifAbsent: [''].
	sourceCode from: from to: to.
	metrics items: (model printPropertiesAsList).
	! !

!RizelMergeBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/14/2012 16:27'!
render
	|view|
	view :=  ROMondrianViewBuilder new.
	visualization setView: view view.
	(RzVisualizerMerge on: merge) listener: self; visualizeOn: view.
	view applyLayout.! !

!RizelMergeBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/13/2012 17:41'!
sourceCode
	^ sourceCode.! !

!RizelMergeBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/13/2012 17:32'!
visualization
	^ visualization! !

ComposableModel subclass: #RizelOptions
	instanceVariableNames: 'add profile compare browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelOptions class methodsFor: 'specs' stamp: ''!
defaultSpec
	<spec>
	^ {#Panel. #changeTableLayout. #listDirection:. #rightToLeft. #addMorph:. {#model. #profile. #defaultSpec}. #addMorph:. {#model. #compare. #defaultSpec}. #hResizing:. #spaceFill. #vResizing:. #shrinkWrap}! !

!RizelOptions class methodsFor: 'specs' stamp: ''!
title
	^ 'Rizel Options'! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
add
	add
		ifNil: [add := self instantiate: ButtonModel.
			add
				whenActionPerformedDo: [browser addBenchmark].
			add label: '+ bench'].
	^ add! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
browser
	^ browser! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
browser: t1 
	browser := t1! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
compare
	compare
		ifNil: [compare := self instantiate: ButtonModel.
			compare
				whenActionPerformedDo: [browser compare].
			compare label: 'Compare'].
	^ compare! !

!RizelOptions methodsFor: 'initialize-release' stamp: ''!
initializeWidgets
	^ self! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
profile
	profile
		ifNil: [profile := self instantiate: ButtonModel.
			profile
				whenActionPerformedDo: [browser profile].
			profile label: 'Profile'].
	^ profile! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
window
	^ window! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
window: t1 
	window := t1! !

ComposableModel subclass: #RoassalModel
	instanceVariableNames: 'builder container stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RoassalModel class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 8/29/2012 04:33'!
defaultSpec
	
	^ SpecLayout composed
		add: {#model. #container};
		yourself.! !

!RoassalModel class methodsFor: 'as yet unclassified' stamp: ''!
title
	^ 'RoassalSpec'! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: ''!
container
	^ container! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 9/28/2012 15:08'!
initializeWidgets

	builder := ROMondrianViewBuilder new.
	stack := ROViewStack new addView: builder view;
				 title: builder title.
	container := (ROMorph on: stack)
					vResizing: #spaceFill;
					hResizing: #spaceFill;
					yourself! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/13/2012 17:58'!
setView: view
	container setView:view.
	self update.! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 8/20/2012 01:49'!
update
	stack signalUpdate.
	container layoutChanged.
	
	! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: ''!
view
	^ builder! !
